Index: /locker/bin/signup-minimal
===================================================================
--- /locker/bin/signup-minimal	(revision 575)
+++ /locker/bin/signup-minimal	(revision 576)
@@ -48,22 +48,20 @@
 attach "$lname" 2>/dev/null
 
-if [ "$lname" != "$USER" ]; then
-  ans=`$WGET -q -O- "http://scripts.mit.edu/~signup/admof.php/$lname/$USER@ATHENA.MIT.EDU"`
-  if [ "$ans" != "yes" ]; then
-    echo
-    echo "ERROR:"
-    echo "It appears as though you are not an administrator of the locker <$lname>."
-    echo "Try running \"fs sa /mit/$lname $USER all\" and starting over."
-    echo "Contact scripts@mit.edu if you are unable to solve the problem."
-    exit 1
-  fi
-fi
-
-attach "$lname" 2>/dev/null
-
 if [ ! -d "/mit/$lname" ]; then
   echo
   echo "ERROR:"
   echo "Cannot find locker <$lname>."
+  exit 1
+fi
+
+principal=`klist -5 | sed -n 's/^Default principal: // p'`
+ans=`$WGET -q -O- "http://scripts.mit.edu/~signup/admof.php/$lname/$principal"`
+if [ "$ans" != "yes" ]; then
+  afsuser=`echo "$principal" | sed 's/@ATHENA.MIT.EDU$//'`
+  echo
+  echo "ERROR:"
+  echo "It appears as though you are not an administrator of the locker <$lname>."
+  echo "Try running \"fs sa /mit/$lname $afsuser all\" and starting over."
+  echo "Contact scripts@mit.edu if you are unable to solve the problem."
   exit 1
 fi
